<template>
        <div class="row contenedorPrincipal p-2 pb-4">
            <div class="col-3">
                <label for="periodoActual" class="form-label">Periodo Actual:</label>
                <input type="date" v-model="data.periodoActual" class="form-control" id="periodoActual" readonly />
            </div>
    
            <div class="col-3">
                <label for="estadoCarga" class="form-label">Estado de Carga:</label>
                <input type="text" v-model="data.d_carga_bloques_inhabilitada" class="form-control"
                    id="d_carga_bloques_inhabilitada" autocomplete="off"/>
                <input type="hidden" v-model="data.carga_bloques_inhabilitada" class="form-control"
                    id="carga_bloques_inhabilitada" autocomplete="off"/>
            </div> 
            <div class="col-3 align-self-end">
                <button type="button" class="btn btn-principal px-3 mt-2" alt="Cambiar Estado" title="Cambiar Estado"
                @click="cambiarEstado()">
                Cambiar estado
                </button> 
             </div>
        </div>
</template>
   
    
<script setup lang="ts">

import { onMounted, reactive } from "vue";
import http from "@/http";
import { BreadCrumbRoute } from "@hcd-bsas/vue3-components";
import { useBreadcrumb } from "@/shared.js";
import { loading, urlApi } from "@/shared.js";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions } from "sweetalert2";

//entities 
import Periodo from "@/entities/Periodo";

const { breadcrumb } = useBreadcrumb();

var data = reactive({
    periodoActual: null as String | null,
    d_carga_bloques_inhabilitada: null as String | null,
    id_periodo: null as Number | null,
    carga_bloques_inhabilitada: null as Number | null,

});

onMounted(async () => {

    breadcrumb?.initRoutes([
        new BreadCrumbRoute("inicio"),
        new BreadCrumbRoute("inhabilitarBecas"),
    ]);

    loading.show();
    await cargarEstado();
    loading.hide();

});

function cambiarEstado() {

    let tipo = data.carga_bloques_inhabilitada;
    let tipoInt = 0;
    let pregunta = '';
    let texto = '';
    if (tipo == 0) {
        pregunta = "¿Confirma deshabilitar la carga de becas ?";
        texto = "Se deshabilito la carga de becas.";
        tipoInt = 1;
    } else {
        pregunta = "¿Confirma habilitar la carga de becas  ?";
        texto = "Se habilitó la carga de becas.";
        tipoInt = 0;
    }

    const swal_error: SweetAlertOptions<any, any> = {
        icon: "error",
        title: "Error",
        html: "",
    }

    Swal.fire({
        icon: "question",
        title: "Confirmaci&oacute;n",
        html: pregunta,
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Confirmar",
        cancelButtonText: "Cancelar",
    }).then(async (result) => {
        if (result.isConfirmed) {
            loading.show();
            var rta = await http.post(urlApi + "cambiarEstado", {
                id_periodo: data.id_periodo,
                inhabilitar_carga_bloques: tipoInt,
            }).then(async () => {

                await cargarEstado();
                Swal.fire({
                    icon: "success",
                    text: texto,
                });


                loading.hide();
            }).catch(function (error: AxiosError<string, any>) {
                console.log(error.response);
                if (error.response) {
                    // Request made and server responded
                    swal_error.html =
                        error.message +
                        " (" +
                        error.code +
                        ")." +
                        "<br />" +
                        error.response.data.substring(
                            error.response.data.indexOf("<h2>") + 4,
                            error.response.data.indexOf("</h2>")
                        );
                    console.log("Error: request made and server responded");
                    console.log(swal_error.html);
                    console.log(error.response);
                } else if (error.request) {
                    // The request was made but no response was received
                    swal_error.html =
                        "Error desconocido. Por favor, avise al Administrador.";
                    console.log("Error: the request was made but no response was received");
                    console.log(error.request);
                } else {
                    // Something happened in setting up the request that triggered an Error
                    swal_error.html =
                        "Error desconocido. Por favor, avise al Administrador.";
                    console.log(
                        "Error: something happened in setting up the request that triggered an error"
                    );
                    console.log(error);
                }
                loading.hide();
                Swal.fire(swal_error);
            });
        }
    });

}


async function cargarEstado() {

    const paramsRequest: any = {};
    await http.request<Periodo[]>({
        method: "GET",
        url: urlApi + "getPeriodoActivo",
        params: paramsRequest,
        transformResponse: [
            (datos: string) => {

                const periodos: Periodo = JSON.parse(datos)["res"][0];
                data.periodoActual = periodos.f_periodo;
                data.carga_bloques_inhabilitada = periodos.carga_bloques_inhabilitada;
                data.d_carga_bloques_inhabilitada = periodos.d_carga_bloques_inhabilitada;
                data.id_periodo = periodos.id_periodo;
            },
        ],
    });

}


</script>
    
    <!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>